"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const server_1 = __importDefault(require("react-dom/server"));
// @ts-ignore
const server_express_1 = require("@react-fullstack/server-express");
const express_1 = __importDefault(require("express"));
class ReactRoute extends react_1.default.Component {
    constructor() {
        super(...arguments);
        this.getApp = (req, res, next) => {
            let reactNodes;
            if (typeof this.props.children === "function") {
                reactNodes = this.props.children(req, res, next);
            }
            else {
                reactNodes = this.props.children;
            }
            res.send(server_1.default.renderToString(react_1.default.createElement(react_1.default.Fragment, null, reactNodes)));
        };
    }
    render() {
        return (react_1.default.createElement(server_express_1.Router, { path: this.props.rootPath || "/" },
            this.props.assetsDir && (react_1.default.createElement(server_express_1.Middleware, { middlewares: [express_1.default.static(this.props.assetsDir, { index: "/" })] })),
            react_1.default.createElement(server_express_1.Route, { path: this.props.indexPath || "/", get: this.getApp })));
    }
}
exports.default = ReactRoute;
